### processing BOLDigger results and merging with OTU file

source("C:/Users/mon_rose/Desktop/functions.R")                      # access some R functions to assign taxonomy based on specific thresholds


#### open the BOLDigger excel file, filter the spreadhseet, remove blanks from first column, change column 1 to LABEL, and save as csv , then merge ###########
TOP_BOLD_ID <- read.csv("C:/Users/mon_rose/Desktop/non concatenated analysis ee 2.3/F_U_cluster_otus/BOLDResults_3_Raw_OTU.csv")
TOP_BOLD_ID$ID <-  sapply(strsplit(as.character(TOP_BOLD_ID$LABEL),';'), "[", 1)            ## adds a column withe the OTU ID
TOP_BOLD_ID$reads <-  sapply(strsplit(as.character(TOP_BOLD_ID$LABEL),';size='), "[", 2)    ## adds a column with the OTU read abundance



## apply taxonomy to OTU file from JAMP
my_OTU_table_raw <- read.csv("C:/Users/mon_rose/Desktop/non concatenated analysis ee 2.3/F_U_cluster_otus/3_raw_OTU_table.csv")
my_OTU_table_raw <- plyr::join(my_OTU_table_raw , TOP_BOLD_ID,type = "left")                 ## merge the two tables together, only keep OTUs in the zero abundance table 
my_OTU_table_raw$Similarity <- as.numeric(my_OTU_table_raw$Similarity)                       ## convert similarity value to numeric
my_OTU_table_raw$OTU_status <- ifelse(my_OTU_table_raw$Similarity >= 98,"Existing","Novel")  ## compute if each OTU matches a record on BOLD or is novel
my_OTU_table_raw95 <- BOLDparser95(my_OTU_table_raw)                                             ## categorize matches into classified and unclassified
my_OTU_table_raw95 <- BOLDparser295(my_OTU_table_raw95)                                          ## remove taxonomy below thresholds

write.csv(my_OTU_table_raw95, "raw_OTU_with_tax95.csv")                                          ## export the file
